﻿Imports System.Data.OleDb
Imports C1.Win.C1FlexGrid

Public Class Form1
    Private _al As ArrayList = New ArrayList()
    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load

        Dim dt As DataTable = New DataTable()
        Dim connectionString As String = "Provider=Microsoft.Jet.OLEDB.4.0;Data Source=" & System.IO.Path.Combine(Environment.GetFolderPath(Environment.SpecialFolder.MyDocuments), "ComponentOne Samples\Common\C1NWind.mdb") & ";"
        Dim conn As OleDbConnection = New OleDbConnection(connectionString)
        Dim adapter As OleDbDataAdapter = New OleDbDataAdapter("Select * from Data", conn)
        adapter.Fill(dt)
        C1FlexGrid1.DataSource = dt
        C1FlexGrid1.Cols.Fixed = 0
        C1FlexGrid1.Cols.Insert(0)
        C1FlexGrid1.Cols(0).Width = 40
        C1FlexGrid1.Cols(0).Editor = New Button()
        For i As Integer = 0 To C1FlexGrid1.Rows.Count - 2
            Dim bt As Button = New Button()
            bt.Text = (i + 1).ToString
            bt.Tag = i
            bt.BackColor = Color.LightGray
            AddHandler bt.Click, AddressOf button_click
            _al.Add(New HostedControl(C1FlexGrid1, bt, i + 1, 0))
        Next
    End Sub

    Private Sub button_click(sender As Object, e As EventArgs)
        Dim bt As Button = sender
        MessageBox.Show("Button " + (bt.Tag + 1).ToString)
    End Sub
    Private Sub C1FlexGrid1_Paint(sender As Object, e As PaintEventArgs) Handles C1FlexGrid1.Paint
        For Each hosted As HostedControl In _al
            hosted.UpdatePosition(C1FlexGrid1.Row, C1FlexGrid1.Col)
        Next
    End Sub
    Private Sub C1FlexGrid1_MouseDown(sender As Object, e As MouseEventArgs) Handles C1FlexGrid1.MouseDown
        If TypeOf C1FlexGrid1.Cols(C1FlexGrid1.MouseCol).Editor Is Button Then
            SendKeys.Send("{ENTER}")
            SendKeys.Send("{ENTER}")
        End If
    End Sub
End Class
Friend Class HostedControl
    Friend _flex As C1FlexGrid
    Friend _ctl As Control
    Friend _row As Row
    Friend _col As Column

    Friend Sub New(ByVal flex As C1FlexGrid, ByVal hosted As Control, ByVal row As Integer, ByVal col As Integer)
        _flex = flex
        _ctl = hosted
        _row = flex.Rows(row)
        _col = flex.Cols(col)
        _flex.Controls.Add(_ctl)
    End Sub

    Friend Function UpdatePosition(ByVal row As Integer, ByVal col As Integer) As Boolean
        Dim r As Integer = _row.Index
        Dim c As Integer = _col.Index
        If r < 0 OrElse c < 0 Then Return False
        Dim rc As Rectangle = _flex.GetCellRect(r, c, False)

        If rc.Width <= 0 OrElse rc.Height <= 0 OrElse Not rc.IntersectsWith(_flex.ClientRectangle) Then
            _ctl.Visible = False
            Return True
        End If

        _ctl.Bounds = rc
        _ctl.Visible = True
        Return True
    End Function
End Class


